// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of scatter
//
// scatter is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// scatter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#ifndef Photon_h
#define Photon_h

#include <iostream>

#include <BinaryPipe/BinaryPipeException.h>
#include <BinaryPipe/MyPhoton.h>

using namespace std;

class Photon : public MyPhoton {
 public:
  Photon( BPipe *bpipe, void *core ) throw ( BinaryPipeException );
  virtual ~Photon( void ) { };

  DVector3* get_surface_norm( ) { return surface_norm; }
  double* get_energy( ) { return energy; }
  double* get_theta( ) { return theta; }
  double* get_phi( ) { return phi; }
  unsigned int* get_id( ) { return id; }
  unsigned int* get_surf_missed( ) { return surf_missed; };

  unsigned int* get_srfno( ) { return srfno; };

  void dpktf_delete( const char *name );

 protected:
  DVector3* surface_norm;
  double* energy;
  double* theta;
  double* phi;
  unsigned int* id;
  unsigned int* surf_missed;
  unsigned int* srfno;

  BPipe* _bpipe;
  
  char *dpktf_data( BPipe* bpipe, void* core, const char *name ) const
    throw ( BinaryPipeException );
  char *hdrf_data( BPipe* bpipe, const char *name, const int idx ) const
    throw ( BinaryPipeException );


};

#endif // #ifndef Photon_h
